/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 08.05.2005                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


// MB_order in SB
const unsigned char SB_row_order[3][9] = { 
	{ 0, 5, 6,11,12,17,18,23,24}, 
	{ 1, 4, 7,10,13,16,19,22,25},
	{ 2, 3, 8, 9,14,15,20,21,26} 
};


//q = quantization_code_table[(c1c0<<4)+QNO], QNO = 0..15, c1c0 = 0..3
const uint32_t quantization_code_table[16*4] = {
	 5,  5,  4,  4,  3,  3,  2,  2,  1,  0,  0,  0,  0,  0,  0,  0,
	 7,  6,  6,  5,  5,  4,  4,  3,  3,  2,  2,  1,  0,  0,  0,  0,
	 8,  8,  7,  7,  6,  6,  5,  5,  4,  4,  3,  3,  2,  2,  1,  0,
	 8,  7,  7,  6,  6,  5,  5,  4,  4,  3,  3,  2,  2,  1,  0,  0
};


//q = quantization_code_table[(c1c0<<4)+QNO], QNO = 0..15, c1c0 = 0..3
const uint32_t quantization_code_table_extended[16*4] = {
	 7,  7,  6,  6,  3,  3,  2,  2,  1,  0,  0,  0,  0,  0,  0,  0,
	 9,  8,  8,  7,  7,  6,  6,  3,  3,  2,  2,  1,  0,  0,  0,  0,
	10, 10,  9,  9,  8,  8,  7,  7,  6,  6,  3,  3,  2,  2,  1,  0,
	12, 11, 11, 10, 10,  9,  9,  8,  8,  7,  7,  6,  6,  5,  4,  4
};


