/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 08.05.2005                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


void encode_PAL_DVSD( uint32_t *src, uint32_t *dst_DV, char color_format );

void encode_5_Video_DIF_blocks( uint32_t *src_5_MBs, uint32_t *dst_5_DIF_blocks, uint8_t Dseq, uint8_t DBN_1st );

int get_compressed_size( uint16_t *dct_block, uint16_t *size_table );

void bit_budgeting( uint16_t *sizetable, uint8_t *QNO, uint8_t *m0_c1_c0 );

void encode_videosegment( uint32_t *src_TMB, uint8_t *QNO, uint8_t *m0_c1_c0, uint32_t *dst_5_DIF_blocksint, uint8_t Dseq, uint8_t DBN_1st );

void interleave_45_MBs_YV12_PAL( uint32_t *src_YUV420_Y, int src_YUV420_Y_pitch, 
						   uint32_t *src_YUV420_U, int src_YUV420_U_pitch, 
					       uint32_t *src_YUV420_V, int src_YUV420_V_pitch, 
					       uint32_t *dst_45_MBs, int DIF_sequence_number, int row_in_SB );

void interleave_9_MBs_YV12_PAL( uint32_t *src_YUV420_Y, int src_YUV420_Y_pitch, 
						  uint32_t *src_YUV420_U, int src_YUV420_U_pitch, 
					      uint32_t *src_YUV420_V, int src_YUV420_V_pitch, 
					      uint32_t *dst );

void interleave_45_MBs_YUY2_PAL( uint32_t *src_YUY2, int src_YUY2_pitch, 
					       uint32_t *dst_45_MBs, int DIF_sequence_number, int row_in_SB );

void interleave_9_MBs_YUY2_PAL( uint32_t *src_YUY2, int src_YUY2_pitch, uint32_t *dst );

void interleave_45_MBs_RGBA_PAL( uint32_t *src, int src_pitch, 
					       uint32_t *dst_45_MBs, int DIF_sequence_number, int row_in_SB );

void encode_6_Header_DIF_blocks( uint32_t *DIF_block, uint32_t DIF_sequence_number, char video_system );

void encode_Audio_DIF_block( uint32_t *DIF_block, uint32_t DIF_sequence_number, uint32_t DIF_block_number, char video_system );
